package com.persagy.dmp.report.entity;

import com.fasterxml.jackson.databind.node.ArrayNode;
import com.vladmihalcea.hibernate.type.json.JsonStringType;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.Type;
import org.hibernate.annotations.TypeDef;

import javax.persistence.*;

@Setter
@Getter
@Entity
@TypeDef(name = "json", typeClass = JsonStringType.class)
@Table(name = "report_config")
public class ReportConfig extends BaseEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private String calculated;
    private String tableName;
    private String mappingName;
    private String group;
    @Type(type = "json")
    private ArrayNode tableGroup;
}
