package com.persagy.dmp.report.entity;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.util.List;

@Setter
@Getter
@Entity
@Table(name = "report_config_group")
public class ReportConfigGroup extends BaseEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private String conlumnName;
    private String conlumnDesc;
    private String method;
    private String value;
    private Integer valueType;
    /**
     * [{
     * "conlumnName":"item_code,category",
     * "valueList":[["1021","Sy"]]
     * }]
     */
    @Transient
    private List<Object[]> valueList;

    public ReportConfigGroup() {
    }

    /**
     * valueList，默认赋值
     */
    public ReportConfigGroup(String conlumnName, List<Object[]> valueList) {
        this.conlumnName = conlumnName;
        this.valueList = valueList;
    }
}
