package com.persagy.dmp.report.entity;

import com.persagy.dmp.report.enumeration.DateType;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;

@Setter
@Getter
@Entity
@Table(name = "report_rwd_object")
public class ReportRwdObject extends BaseEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    private String projectId;
    private String objType;
    private String classCode;
    private String year;
    private String month;
    private String day;
    private String hour;
    private String season;
    private String week;
    private String createTime;
    private Long rwdObjectNum;
    @Enumerated(value = EnumType.STRING)
    private DateType dateType;

    public ReportRwdObject() {

    }

    public ReportRwdObject(ReportRwdObject rwdObject) {
        this.id = rwdObject.id;
        this.projectId = rwdObject.projectId;
        this.objType = rwdObject.objType;
        this.classCode = rwdObject.classCode;
        this.year = rwdObject.year;
        this.month = rwdObject.month;
        this.day = rwdObject.day;
        this.hour = rwdObject.hour;
        this.season = rwdObject.season;
        this.week = rwdObject.week;
        this.createTime = rwdObject.createTime;
        this.rwdObjectNum = rwdObject.rwdObjectNum;
        this.dateType = rwdObject.dateType;
    }
}
