package com.persagy.dmp.report.service;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.report.common.criteria.CriteriaUtils;
import com.persagy.dmp.report.common.criteria.JacksonCriteria;
import com.persagy.dmp.report.entity.BaseEntity;
import com.persagy.dmp.report.entity.QReportConfig;
import com.persagy.dmp.report.entity.ReportConfig;
import com.querydsl.core.Tuple;
import com.querydsl.core.types.dsl.BooleanExpression;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

/**
 * @author fengyanjie
 */
@Service
public class ReportConfigService implements BaseService {

    @Override
    public List<BooleanExpression> parse(ObjectNode criteria) {
        List<BooleanExpression> exps = new LinkedList<>();
        QReportConfig qt = QReportConfig.reportConfig;
        exps.addAll(CriteriaUtils.parse(qt.calculated, criteria.get("calculated")));
        exps.addAll(CriteriaUtils.parse(qt.tableName, criteria.get("tableName")));
        exps.addAll(CriteriaUtils.parse(qt.mappingName, criteria.get("mappingName")));
        exps.addAll(CriteriaUtils.parse(qt.group, criteria.get("group")));
        return exps;
    }

    @Override
    public List<BaseEntity> getData(PagedResponse<Tuple> tuplePagedResponse, List<JacksonCriteria.Calculated> calculatedColumns) {
        List<BaseEntity> list = new ArrayList<>();
        QReportConfig qt = QReportConfig.reportConfig;
        tuplePagedResponse.getData().forEach(item -> {
            ReportConfig entity = new ReportConfig();
            entity.setCalculated(item.get(qt.calculated));
            entity.setTableName(item.get(qt.tableName));
            entity.setMappingName(item.get(qt.mappingName));
            entity.setGroup(item.get(qt.group));
            entity.setTableGroup(item.get(qt.tableGroup));
            list.add(entity);
        });
        return list;
    }
}
