package com.persagy.dmp.report.service;

import com.persagy.dmp.report.entity.alarm.QAlarmItem;
import com.persagy.dmp.report.entity.rwd.QClassDef;
import com.querydsl.core.Tuple;
import com.querydsl.jpa.impl.JPAQueryFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author fengyanjie
 */
@Slf4j
@Service
public class TestService {

    @Autowired
    JPAQueryFactory queryFactory;

    public List<Object[]> itemCode() {
        List<Object[]> result = new ArrayList<>();
        QAlarmItem qt = QAlarmItem.alarmItem;
        List<String> fetch = queryFactory.selectDistinct(qt.code).from(qt).where(qt.valid.eq(1)).fetch();
        fetch.forEach(item -> {
            result.add(new String[]{item});
        });
        return result;
    }

    public List<Object[]> category() {
        List<Object[]> result = new ArrayList<>();
        QAlarmItem qt = QAlarmItem.alarmItem;
        List<String> fetch = queryFactory.selectDistinct(qt.category).from(qt).where(qt.valid.eq(1)).fetch();
        fetch.forEach(item -> {
            result.add(new String[]{item});
        });
        return result;
    }

    public List<Object[]> classCodeObjType() {
        List<Object[]> result = new ArrayList<>();
        QClassDef qt = QClassDef.classDef;
        List<Tuple> fetch = queryFactory.selectDistinct(qt.code, qt.objType).from(qt).fetch();
        for (Tuple tuple : fetch) {
            result.add(new String[]{tuple.get(qt.code), tuple.get(qt.objType).name()});
        }
        return result;
    }
}
